/*
    Copyright 2009,2010 Roland Bouman 
    (Roland.Bouman@gmail.com, http://rpbouman.blogspot.com/, http://code.google.com/p/xmla4js)
    
    Note: some portions of the API documentation were adopted from the original XML/A specification. 
    I believe that this constitutes fair use, 
    but if you have reason to believe that the documentation violates any copyright, 
    or is otherwise incompatible with the LGPL license please contact me.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/    

var Xmla;(function(){(function(Date,undefined){var origParse=Date.parse,numericKeys=[1,4,5,6,7,10,11];Date.parse=function(date){var timestamp,struct,minutesOffset=0;if((struct=/^(\d{4}|[+\-]\d{6})(?:-(\d{2})(?:-(\d{2}))?)?(?:T(\d{2}):(\d{2})(?::(\d{2})(?:\.(\d{3}))?)?(?:(Z)|([+\-])(\d{2})(?::(\d{2}))?)?)?$/.exec(date))){for(var i=0,k;(k=numericKeys[i]);++i){struct[k]=+struct[k]||0;}
struct[2]=(+struct[2]||1)-1;struct[3]=+struct[3]||1;if(struct[8]!=='Z'&&struct[9]!==undefined){minutesOffset=struct[10]*60+struct[11];if(struct[9]==='+'){minutesOffset=0-minutesOffset;}}
timestamp=Date.UTC(struct[1],struct[2],struct[3],struct[4],struct[5]+minutesOffset,struct[6],struct[7]);}
else{timestamp=origParse?origParse(date):NaN;}
return timestamp;};function pad(number){var r=String(number);if(r.length===1){r='0'+r;}
return r;};Date.prototype.toString=function(){var s=this.getFullYear()
+'-'+pad(this.getMonth()+1)
+'-'+pad(this.getDate())
+'T'+pad(this.getHours())
+':'+pad(this.getMinutes())
+':'+pad(this.getSeconds())
+'.'+String((this.getMilliseconds()/1000).toFixed(3)).slice(2,5);var tzInHours=-this.getTimezoneOffset()/60;s+=(tzInHours>0)?'+':'-';s+=pad(tzInHours)+':';var tzInMin=this.getTimezoneOffset()%60;tzInMin=tzInMin<0?-tzInMin:tzInMin;s+=pad(tzInMin);return s;};}(Date));var _soap="http://www.w3.org/2003/05/",_xmlnsSOAPenvelope=_soap+"soap-envelope",_xmlnsSOAPenvelope1="http://schemas.xmlsoap.org/soap/envelope/",_xmlnsSOAPenvelopePrefix="SOAP-ENV",_xmlnsIsSOAPenvelope="xmlns:"+_xmlnsSOAPenvelopePrefix+"=\""+_xmlnsSOAPenvelope+"\"",_SOAPencodingStyle=_xmlnsSOAPenvelopePrefix+":encodingStyle=\""+_soap+"soap-encoding\"",_ms="urn:schemas-microsoft-com:",_xmlnsXmla=_ms+"xml-analysis",_xmlnsIsXmla="xmlns=\""+_xmlnsXmla+"\"",_xmlnsSQLPrefix="sql",_xmlnsSQL=_ms+"xml-sql",_xmlnsSchema="http://www.w3.org/2001/XMLSchema",_xmlnsSchemaPrefix=window.ActiveXObject?"s":"xsd",_xmlnsSchemaInstance="http://www.w3.org/2001/XMLSchema-instance",_xmlnsSchemaInstancePrefix="xsi",_xmlnsRowset=_xmlnsXmla+":rowset",_xmlnsEmpty=_xmlnsXmla+":empty",_xmlnsResultset=_xmlnsXmla+":mddataset",_useAX=window.ActiveXObject?true:false;function _ajax(options){var xhr,handlerCalled=false,handler=function(){handlerCalled=true;switch(xhr.readyState){case 0:options.aborted(xhr);break;case 4:if(xhr.status===200){options.complete(xhr);}
else{options.error(Xmla.Exception._newError("HTTP_ERROR","_ajax",options,xhr.responseText));}
break;}};if(_useAX){xhr=new ActiveXObject("MSXML2.XMLHTTP.3.0");}
else{xhr=new XMLHttpRequest();}
if(options.username&&options.password){xhr.open("POST",options.url,options.async,options.username,options.password);}else{xhr.open("POST",options.url,options.async);}
xhr.onreadystatechange=handler;xhr.setRequestHeader("X-PINGRUN","ping");if(options.method==Xmla.METHOD_DISCOVER)
xhr.setRequestHeader("Content-Type","application/soap+xml; action=\"urn:schemas-microsoft-com:xml-analysis:Discover\"");else if(options.method==Xmla.METHOD_EXECUTE)
xhr.setRequestHeader("Content-Type","application/soap+xml; action=\"urn:schemas-microsoft-com:xml-analysis:Execute\"");else
xhr.setRequestHeader("Content-Type","application/soap+xml");if(!_useAX)
xhr.overrideMimeType("text/xml");xhr.send(options.data);if(!options.async&&!handlerCalled){handler.call(xhr);}
return xhr;}
function _isUnd(arg){return typeof(arg)==="undefined";}
function _xmlEncodeListEntry(value){return value!=null?value.replace(/\&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;"):value;}
var _getElementsByTagNameNS=document.getElementsByTagNameNS?function(node,ns,prefix,tagName){return node.getElementsByTagNameNS(ns,tagName);}:function(node,ns,prefix,tagName){if(prefix){return node.getElementsByTagName(prefix+":"+tagName);}
else{return node.getElementsByTagName(tagName);}};var _getAttributeNS=document.documentElement.getAttributeNS?function(element,ns,prefix,attributeName){return element.getAttributeNS(ns,attributeName);}:function(element,ns,prefix,attributeName){if(prefix){return element.getAttribute(prefix+":"+attributeName);}
else{return element.getAttribute(attributeName);}};function _getXmlaSoapList(container,listType,items){var numItems,i,entry,property,item,msg="<"+container+">";if(items){msg+=" <"+listType+">";for(property in items){if(items.hasOwnProperty(property)){item=items[property];msg+="<"+property+">";if(typeof(item)==="array"){for(entry,i=0,numItems=item.length;i<numItems;i+=1){entry=item[i];msg+="<Value>"+_xmlEncodeListEntry(entry)+"</Value>";}}else{msg+=_xmlEncodeListEntry(item);}
msg+="</"+property+">";}}
msg+="</"+listType+">";}
msg+="</"+container+">";return msg;}
var _xmlRequestType="RequestType";function _getXmlaSoapMessage(options){var msg="",method=options.method,exception=null;msg+="<"+_xmlnsSOAPenvelopePrefix+":Envelope "+_xmlnsIsSOAPenvelope+" "+_SOAPencodingStyle+">"+"<"+_xmlnsSOAPenvelopePrefix+":Body>"+"<"+method+" "+_xmlnsIsXmla+" "+_SOAPencodingStyle+">";switch(method){case Xmla.METHOD_DISCOVER:if(options.requestType){msg+="<"+_xmlRequestType+">"+options.requestType+"</"+_xmlRequestType+">"+
_getXmlaSoapList("Restrictions","RestrictionList",options.restrictions)+
_getXmlaSoapList("Properties","PropertyList",options.properties);}
else{exception=Xmla.Exception._newError("MISSING_REQUEST_TYPE","Xmla._getXmlaSoapMessage",options,null);}
break;case Xmla.METHOD_EXECUTE:if(options.statement){msg+=""+"<Command>"+"<Statement>"+_xmlEncodeListEntry(options.statement)+"</Statement>"+"</Command>"+
_getXmlaSoapList("Properties","PropertyList",options.properties);}
else{exception=Xmla.Exception._newError("MISSING_REQUEST_TYPE","Xmla._getXmlaSoapMessage",options,null);}
break;default:}
if(exception!==null){exception._throw();}
msg+="</"+method+">"+"</"+_xmlnsSOAPenvelopePrefix+":Body>"+"</"+_xmlnsSOAPenvelopePrefix+":Envelope>";return msg;}
function _applyProps(object,properties,overwrite){if(properties&&(!object)){object={};}
for(var property in properties){if(properties.hasOwnProperty(property)){if(overwrite||_isUnd(object.property)){object[property]=properties[property];}}}
return object;}
Xmla=function(options){this.listeners={};this.listeners[Xmla.EVENT_REQUEST]=[];this.listeners[Xmla.EVENT_SUCCESS]=[];this.listeners[Xmla.EVENT_ERROR]=[];this.listeners[Xmla.EVENT_DISCOVER]=[];this.listeners[Xmla.EVENT_DISCOVER_SUCCESS]=[];this.listeners[Xmla.EVENT_DISCOVER_ERROR]=[];this.listeners[Xmla.EVENT_EXECUTE]=[];this.listeners[Xmla.EVENT_EXECUTE_SUCCESS]=[];this.listeners[Xmla.EVENT_EXECUTE_ERROR]=[];this.options=_applyProps(_applyProps({},Xmla.defaultOptions,true),options,true);return this;};Xmla.defaultOptions={requestTimeout:30000,async:false};Xmla.METHOD_DISCOVER="Discover";Xmla.METHOD_EXECUTE="Execute";var _xmlaDISCOVER="DISCOVER_";var _xmlaMDSCHEMA="MDSCHEMA_";var _xmlaDBSCHEMA="DBSCHEMA_";Xmla.DISCOVER_DATASOURCES=_xmlaDISCOVER+"DATASOURCES";Xmla.DISCOVER_PROPERTIES=_xmlaDISCOVER+"PROPERTIES";Xmla.DISCOVER_SCHEMA_ROWSETS=_xmlaDISCOVER+"SCHEMA_ROWSETS";Xmla.DISCOVER_ENUMERATORS=_xmlaDISCOVER+"ENUMERATORS";Xmla.DISCOVER_KEYWORDS=_xmlaDISCOVER+"KEYWORDS";Xmla.DISCOVER_LITERALS=_xmlaDISCOVER+"LITERALS";Xmla.DBSCHEMA_CATALOGS=_xmlaDBSCHEMA+"CATALOGS";Xmla.DBSCHEMA_COLUMNS=_xmlaDBSCHEMA+"COLUMNS";Xmla.DBSCHEMA_PROVIDER_TYPES=_xmlaDBSCHEMA+"PROVIDER_TYPES";Xmla.DBSCHEMA_SCHEMATA=_xmlaDBSCHEMA+"SCHEMATA";Xmla.DBSCHEMA_TABLES=_xmlaDBSCHEMA+"TABLES";Xmla.DBSCHEMA_TABLES_INFO=_xmlaDBSCHEMA+"TABLES_INFO";Xmla.DBSCHEMA_PRIMARY_KEYS=_xmlaDBSCHEMA+"PRIMARY_KEYS";Xmla.DBSCHEMA_FOREIGN_KEYS=_xmlaDBSCHEMA+"FOREIGN_KEYS";Xmla.MDSCHEMA_ACTIONS=_xmlaMDSCHEMA+"ACTIONS";Xmla.MDSCHEMA_CUBES=_xmlaMDSCHEMA+"CUBES";Xmla.MDSCHEMA_DIMENSIONS=_xmlaMDSCHEMA+"DIMENSIONS";Xmla.MDSCHEMA_FUNCTIONS=_xmlaMDSCHEMA+"FUNCTIONS";Xmla.MDSCHEMA_HIERARCHIES=_xmlaMDSCHEMA+"HIERARCHIES";Xmla.MDSCHEMA_LEVELS=_xmlaMDSCHEMA+"LEVELS";Xmla.MDSCHEMA_MEASURES=_xmlaMDSCHEMA+"MEASURES";Xmla.MDSCHEMA_MEMBERS=_xmlaMDSCHEMA+"MEMBERS";Xmla.MDSCHEMA_PROPERTIES=_xmlaMDSCHEMA+"PROPERTIES";Xmla.MDSCHEMA_SETS=_xmlaMDSCHEMA+"SETS";Xmla.EVENT_REQUEST="request";Xmla.EVENT_SUCCESS="success";Xmla.EVENT_ERROR="error";Xmla.EVENT_EXECUTE="execute";Xmla.EVENT_EXECUTE_SUCCESS="executesuccess";Xmla.EVENT_EXECUTE_ERROR="executeerror";Xmla.EVENT_DISCOVER="discover";Xmla.EVENT_DISCOVER_SUCCESS="discoversuccess";Xmla.EVENT_DISCOVER_ERROR="discovererror";Xmla.EVENT_GENERAL=[Xmla.EVENT_REQUEST,Xmla.EVENT_SUCCESS,Xmla.EVENT_ERROR];Xmla.EVENT_DISCOVER_ALL=[Xmla.EVENT_DISCOVER,Xmla.EVENT_DISCOVER_SUCCESS,Xmla.EVENT_DISCOVER_ERROR];Xmla.EVENT_EXECUTE_ALL=[Xmla.EVENT_EXECUTE,Xmla.EVENT_EXECUTE_SUCCESS,Xmla.EVENT_EXECUTE_ERROR];Xmla.EVENT_ALL=[].concat(Xmla.EVENT_GENERAL,Xmla.EVENT_DISCOVER_ALL,Xmla.EVENT_EXECUTE_ALL);Xmla.PROP_DATASOURCEINFO="DataSourceInfo";Xmla.PROP_CATALOG="Catalog";Xmla.PROP_CUBE="Cube";Xmla.PROP_FORMAT="Format";Xmla.PROP_FORMAT_TABULAR="Tabular";Xmla.PROP_FORMAT_MULTIDIMENSIONAL="Multidimensional";Xmla.PROP_AXISFORMAT="AxisFormat";Xmla.PROP_AXISFORMAT_TUPLE="TupleFormat";Xmla.PROP_AXISFORMAT_CLUSTER="ClusterFormat";Xmla.PROP_AXISFORMAT_CUSTOM="CustomFormat";Xmla.PROP_CONTENT="Content";Xmla.PROP_CONTENT_DATA="Data";Xmla.PROP_CONTENT_NONE="None";Xmla.PROP_CONTENT_SCHEMA="Schema";Xmla.PROP_CONTENT_SCHEMADATA="SchemaData";Xmla.prototype={listeners:null,soapMessage:null,response:null,responseText:null,responseXML:null,setOptions:function(options){_applyProps(this.options,options,true);},addListener:function(listener){var events=listener.events;if(!events){Xmla.Exception._newError("NO_EVENTS_SPECIFIED","Xmla.addListener",listener,null)._throw();}
if(typeof(events)==="string"){if(events==="all"){events=Xmla.EVENT_ALL;}else{events=events.split(",");}}
if(!(events instanceof Array)){Xmla.Exception._newError("WRONG_EVENTS_FORMAT","Xmla.addListener",listener,null)._throw();}
var numEvents=events.length;var eventName,myListeners;for(var i=0;i<numEvents;i+=1){eventName=events[i].replace(/\s+/g,"");myListeners=this.listeners[eventName];if(!myListeners){Xmla.Exception._newError("UNKNOWN_EVENT","Xmla.addListener",listener,null)._throw();}
if(typeof(listener.handler)=="function"){if(!listener.scope){listener.scope=window;}
myListeners.push(listener);}
else{Xmla.Exception._newError("INVALID_EVENT_HANDLER","Xmla.addListener",listener,null)._throw();}}},_fireEvent:function(eventName,eventData,cancelable){var listeners=this.listeners[eventName];if(!listeners){Xmla.Exception._newError("UNKNOWN_EVENT","Xmla._fireEvent",eventName,null)._throw();}
var numListeners=listeners.length;var outcome=true;if(numListeners){var listener,listenerResult;for(var i=0;i<numListeners;i+=1){listener=listeners[i];listenerResult=listener.handler.call(listener.scope,eventName,eventData,this);if(cancelable&&listenerResult===false){outcome=false;break;}}}
else
if(eventName==="error"){eventData.exception._throw();}
return outcome;},request:function(options){var ex,xmla=this;this.response=null;this.responseText=null;this.responseXML=null;if(!options.url){if(this.options.url){options.url=this.options.url;}
else{ex=Xmla.Exception._newError("MISSING_URL","Xmla.request",options,null);ex._throw();}}
options.properties=_applyProps(options.properties,this.options.properties,false);options.restrictions=_applyProps(options.restrictions,this.options.restrictions,false);if(_isUnd(options.async)&&!_isUnd(this.options.async)){options.async=this.options.async;}
if(_isUnd(options.requestTimeout)&&!_isUnd(this.options.requestTimeout)){options.requestTimeout=this.options.requestTimeout;}
if(!options.username&&this.options.username){options.username=this.options.username;}
if(!options.password&&this.options.password){options.password=this.options.password;}
var soapMessage=_getXmlaSoapMessage(options);this.soapMessage=soapMessage;var myXhr;var ajaxOptions={async:options.async,timeout:options.requestTimeout,data:soapMessage,error:function(exception){options.exception=exception;xmla._requestError(options);},complete:function(xhr){options.xhr=xhr;xmla._requestSuccess(options);},url:options.url,method:options.method};if(options.username){ajaxOptions.username=options.username;}
if(options.password){ajaxOptions.password=options.password;}
if(this._fireEvent(Xmla.EVENT_REQUEST,options,true)&&((options.method==Xmla.METHOD_DISCOVER&&this._fireEvent(Xmla.EVENT_DISCOVER,options))||(options.method==Xmla.METHOD_EXECUTE&&this._fireEvent(Xmla.EVENT_EXECUTE,options)))){myXhr=_ajax(ajaxOptions);}
return this.response;},_requestError:function(options){if(options.error)options.error.call(options.scope?options.scope:null,this,options,options.exception);if(options.callback)options.callback.call(options.scope?options.scope:null,Xmla.EVENT_ERROR,this,options,options.exception);this._fireEvent("error",options);},_requestSuccess:function(request){var xhr=request.xhr;this.responseText=xhr.responseText;if(_useAX)
this.responseXML=_createXmlDoc(this.responseText);else
this.responseXML=xhr.responseXML;var method=request.method;var soapFault=_getElementsByTagNameNS(this.responseXML,_xmlnsSOAPenvelope,_xmlnsSOAPenvelopePrefix,"Fault");var soapFault1=_getElementsByTagNameNS(this.responseXML,_xmlnsSOAPenvelope1,_xmlnsSOAPenvelopePrefix,"Fault");if(soapFault.length||soapFault1.length){if(soapFault.length)
soapFault=soapFault.item(0);else
soapFault=soapFault1.item(0);request.exception=new Xmla.Exception(Xmla.Exception.TYPE_ERROR,soapFault.getElementsByTagName("faultcode").item(0).childNodes.item(0).data,soapFault.getElementsByTagName("faultstring").item(0).childNodes.item(0).data,null,"_requestSuccess",request);switch(method){case Xmla.METHOD_DISCOVER:this._fireEvent(Xmla.EVENT_DISCOVER_ERROR,request);break;case Xmla.METHOD_EXECUTE:this._fireEvent(Xmla.EVENT_EXECUTE_ERROR,request);break;}
if(request.error)request.error.call(request.scope?request.scope:null,this,request,request.exception);if(request.callback)request.callback.call(request.scope?request.scope:null,Xmla.EVENT_ERROR,this,request,request.exception);this._fireEvent(Xmla.EVENT_ERROR,request);}
else{switch(method){case Xmla.METHOD_DISCOVER:var rowset=new Xmla.Rowset(this.responseXML,request.requestType);request.rowset=rowset;this.response=rowset;this._fireEvent(Xmla.EVENT_DISCOVER_SUCCESS,request);break;case Xmla.METHOD_EXECUTE:var resultset;var format=request.properties[Xmla.PROP_FORMAT];switch(format){case Xmla.PROP_FORMAT_TABULAR:resultset=new Xmla.Rowset(this.responseXML);break;case Xmla.PROP_FORMAT_MULTIDIMENSIONAL:break;}
request.resultset=resultset;this.response=resultset;this._fireEvent(Xmla.EVENT_EXECUTE_SUCCESS,request);break;}
if(request.success)request.success.call(request.scope?request.scope:null,this,request,this.response);if(request.callback)request.callback.call(request.scope?request.scope:null,Xmla.EVENT_SUCCESS,this,request,this.response);this._fireEvent(Xmla.EVENT_SUCCESS,request);}},execute:function(options){var properties=options.properties;if(!properties){properties={};options.properties=properties;}
_applyProps(properties,this.options.properties,false)
if(!properties[Xmla.PROP_CONTENT]){properties[Xmla.PROP_CONTENT]=Xmla.PROP_CONTENT_SCHEMADATA;}
if(!properties[Xmla.PROP_FORMAT]){options.properties[Xmla.PROP_FORMAT]=Xmla.PROP_FORMAT_MULTIDIMENSIONAL;}
var request=_applyProps(options,{method:Xmla.METHOD_EXECUTE},true);return this.request(request);},executeTabular:function(options){if(!options.properties){options.properties={};}
options.properties[Xmla.PROP_FORMAT]=Xmla.PROP_FORMAT_TABULAR;return this.execute(options);},executeMultiDimensional:function(options){if(!options.properties){options.properties={};}
options.properties[Xmla.PROP_FORMAT]=Xmla.PROP_FORMAT_MULTIDIMENSIONAL;return this.execute(options);},discover:function(options){var request=_applyProps(options,{method:Xmla.METHOD_DISCOVER},true);if(!request.requestType){request.requestType=this.options.requestType;}
return this.request(request);},discoverDataSources:function(options){var request=_applyProps(options,{requestType:Xmla.DISCOVER_DATASOURCES},true);return this.discover(request);},discoverProperties:function(options){var request=_applyProps(options,{requestType:Xmla.DISCOVER_PROPERTIES},true);return this.discover(request);},discoverSchemaRowsets:function(options){var request=_applyProps(options,{requestType:Xmla.DISCOVER_SCHEMA_ROWSETS},true);return this.discover(request);},discoverEnumerators:function(options){var request=_applyProps(options,{requestType:Xmla.DISCOVER_ENUMERATORS},true);return this.discover(request);},discoverKeywords:function(options){var request=_applyProps(options,{requestType:Xmla.DISCOVER_KEYWORDS},true);return this.discover(request);},discoverLiterals:function(options){var request=_applyProps(options,{requestType:Xmla.DISCOVER_LITERALS},true);return this.discover(request);},discoverDBCatalogs:function(options){var request=_applyProps(options,{requestType:Xmla.DBSCHEMA_CATALOGS},true);return this.discover(request);},discoverDBColumns:function(options){var request=_applyProps(options,{requestType:Xmla.DBSCHEMA_COLUMNS},true);return this.discover(request);},discoverDBProviderTypes:function(options){var request=_applyProps(options,{requestType:Xmla.DBSCHEMA_PROVIDER_TYPES},true);return this.discover(request);},discoverDBSchemata:function(options){var request=_applyProps(options,{requestType:Xmla.DBSCHEMA_SCHEMATA},true);return this.discover(request);},discoverDBTables:function(options){var request=_applyProps(options,{requestType:Xmla.DBSCHEMA_TABLES},true);return this.discover(request);},discoverDBTablesInfo:function(options){var request=_applyProps(options,{requestType:Xmla.DBSCHEMA_TABLES_INFO},true);return this.discover(request);},discoverDBPrimaryKeys:function(options){var request=_applyProps(options,{requestType:Xmla.DBSCHEMA_PRIMARY_KEYS},true);return this.discover(request);},discoverDBForeignKeys:function(options){var request=_applyProps(options,{requestType:Xmla.DBSCHEMA_FOREIGN_KEYS},true);return this.discover(request);},discoverMDActions:function(options){var request=_applyProps(options,{requestType:Xmla.MDSCHEMA_ACTIONS},true);return this.discover(request);},discoverMDCubes:function(options){var request=_applyProps(options,{requestType:Xmla.MDSCHEMA_CUBES},true);return this.discover(request);},discoverMDDimensions:function(options){var request=_applyProps(options,{requestType:Xmla.MDSCHEMA_DIMENSIONS},true);return this.discover(request);},discoverMDFunctions:function(options){var request=_applyProps(options,{requestType:Xmla.MDSCHEMA_FUNCTIONS},true);return this.discover(request);},discoverMDHierarchies:function(options){var request=_applyProps(options,{requestType:Xmla.MDSCHEMA_HIERARCHIES},true);return this.discover(request);},discoverMDLevels:function(options){var request=_applyProps(options,{requestType:Xmla.MDSCHEMA_LEVELS},true);return this.discover(request);},discoverMDMeasures:function(options){var request=_applyProps(options,{requestType:Xmla.MDSCHEMA_MEASURES},true);return this.discover(request);},discoverMDMembers:function(options){var request=_applyProps(options,{requestType:Xmla.MDSCHEMA_MEMBERS},true);return this.discover(request);},discoverMDProperties:function(options){var request=_applyProps(options,{requestType:Xmla.MDSCHEMA_PROPERTIES},true);return this.discover(request);},discoverMDSets:function(options){var request=_applyProps(options,{requestType:Xmla.MDSCHEMA_SETS},true);return this.discover(request);}};function _getRowSchema(xmlDoc){var types=_getElementsByTagNameNS(xmlDoc,_xmlnsSchema,_xmlnsSchemaPrefix,"complexType");var numTypes=types.length,type,i;for(i=0;i<numTypes;i+=1){type=types.item(i);if(type.getAttribute("name")==="row"){return type;}}
return null;}
function _createXmlDoc(str){var xml=null;if(document.implementation&&document.implementation.createDocument){if(!str){return document.implementation.createDocument("","",null);}
var parser=new DOMParser();try{xml=parser.parseFromString(str,"text/xml");}catch(e){alert('XML parsing error. Either the XML file is not well-formed or your browser sucks.');}
return xml;}else if(window.ActiveXObject){xml=new ActiveXObject("Microsoft.XMLDOM");if(!str)
return xml;xml.loadXML(str);if(xml.parseError.errorCode){alert('IE XML ERROR: '+xml.parseError.reason+' ('+xml.parseError.errorCode+')');return null;}
return xml;}else{alert("Ooops - no XML parser available");return null;}}
Xmla.Rowset=function(node,requestType){this._node=node;this._type=requestType;this._initData();return this;};Xmla.Rowset.MD_DIMTYPE_UNKNOWN=0;Xmla.Rowset.MD_DIMTYPE_TIME=1;Xmla.Rowset.MD_DIMTYPE_MEASURE=2;Xmla.Rowset.MD_DIMTYPE_OTHER=3;Xmla.Rowset.MD_DIMTYPE_QUANTITATIVE=5;Xmla.Rowset.MD_DIMTYPE_ACCOUNTS=6;Xmla.Rowset.MD_DIMTYPE_CUSTOMERS=7;Xmla.Rowset.MD_DIMTYPE_PRODUCTS=8;Xmla.Rowset.MD_DIMTYPE_SCENARIO=9;Xmla.Rowset.MD_DIMTYPE_UTILIY=10;Xmla.Rowset.MD_DIMTYPE_CURRENCY=11;Xmla.Rowset.MD_DIMTYPE_RATES=12;Xmla.Rowset.MD_DIMTYPE_CHANNEL=13;Xmla.Rowset.MD_DIMTYPE_PROMOTION=14;Xmla.Rowset.MD_DIMTYPE_ORGANIZATION=15;Xmla.Rowset.MD_DIMTYPE_BILL_OF_MATERIALS=16;Xmla.Rowset.MD_DIMTYPE_GEOGRAPHY=17;Xmla.Rowset.MD_STRUCTURE_FULLYBALANCED=0;Xmla.Rowset.MD_STRUCTURE_RAGGEDBALANCED=1;Xmla.Rowset.MD_STRUCTURE_UNBALANCED=2;Xmla.Rowset.MD_STRUCTURE_NETWORK=3;Xmla.Rowset.MD_USER_DEFINED=1
Xmla.Rowset.MD_SYSTEM_ENABLED=2
Xmla.Rowset.MD_SYSTEM_INTERNAL=4
Xmla.Rowset.KEYS={};Xmla.Rowset.KEYS[Xmla.DBSCHEMA_CATALOGS]=["CATALOG_NAME"];Xmla.Rowset.KEYS[Xmla.DBSCHEMA_COLUMNS]=["TABLE_CATALOG","TABLE_NAME","COLUMN_NAME"];Xmla.Rowset.KEYS[Xmla.DBSCHEMA_PROVIDER_TYPES]=["TYPE_NAME"];Xmla.Rowset.KEYS[Xmla.DBSCHEMA_SCHEMATA]=["CATALOG_NAME","SCHEMA_NAME"];Xmla.Rowset.KEYS[Xmla.DBSCHEMA_TABLES]=["TABLE_CATALOG","TABLE_NAME"];Xmla.Rowset.KEYS[Xmla.DBSCHEMA_TABLES_INFO]=["TABLE_CATALOG","TABLE_NAME"];Xmla.Rowset.KEYS[Xmla.DISCOVER_DATASOURCES]=["DataSourceName"];Xmla.Rowset.KEYS[Xmla.DISCOVER_ENUMERATORS]=["EnumName","ElementName"];Xmla.Rowset.KEYS[Xmla.DISCOVER_KEYWORDS]=["Keyword"];Xmla.Rowset.KEYS[Xmla.DISCOVER_LITERALS]=["LiteralName"];Xmla.Rowset.KEYS[Xmla.DISCOVER_PROPERTIES]=["PropertyName"];Xmla.Rowset.KEYS[Xmla.DISCOVER_SCHEMA_ROWSETS]=["SchemaName"];Xmla.Rowset.KEYS[Xmla.MDSCHEMA_ACTIONS]=["CATALOG_NAME","CUBE_NAME","ACTION_NAME"];Xmla.Rowset.KEYS[Xmla.MDSCHEMA_CUBES]=["CATALOG_NAME","CUBE_NAME"];Xmla.Rowset.KEYS[Xmla.MDSCHEMA_DIMENSIONS]=["CATALOG_NAME","CUBE_NAME","DIMENSION_UNIQUE_NAME"];Xmla.Rowset.KEYS[Xmla.MDSCHEMA_FUNCTIONS]=["FUNCTION_NAME","PARAMETER_LIST"];Xmla.Rowset.KEYS[Xmla.MDSCHEMA_HIERARCHIES]=["CATALOG_NAME","CUBE_NAME","DIMENSION_UNIQUE_NAME","HIERARCHY_UNIQUE_NAME"];Xmla.Rowset.KEYS[Xmla.MDSCHEMA_LEVELS]=["CATALOG_NAME","CUBE_NAME","DIMENSION_UNIQUE_NAME","HIERARCHY_UNIQUE_NAME","LEVEL_UNIQUE_NAME"];Xmla.Rowset.KEYS[Xmla.MDSCHEMA_MEASURES]=["CATALOG_NAME","CUBE_NAME","MEASURE_NAME"];Xmla.Rowset.KEYS[Xmla.MDSCHEMA_MEMBERS]=["CATALOG_NAME","CUBE_NAME","DIMENSION_UNIQUE_NAME","HIERARCHY_UNIQUE_NAME","LEVEL_UNIQUE_NAME","MEMBER_UNIQUE_NAME"];Xmla.Rowset.KEYS[Xmla.MDSCHEMA_PROPERTIES]=[];Xmla.Rowset.KEYS[Xmla.MDSCHEMA_SETS]=[];Xmla.Rowset.prototype={_node:null,_type:null,_row:null,_rows:null,numRows:null,fieldOrder:null,fields:null,_fieldCount:null,_initData:function(){this._rows=_getElementsByTagNameNS(this._node,_xmlnsRowset,null,"row");this.numRows=this._rows?this._rows.length:0;this.reset();this.fieldOrder=[];this.fields={};this._fieldCount=0;var rowSchema=_getRowSchema(this._node);if(rowSchema){var seq=_getElementsByTagNameNS(rowSchema,_xmlnsSchema,_xmlnsSchemaPrefix,"choice").item(0),seqChildren=seq.childNodes,numChildren=seqChildren.length,seqChild,fieldLabel,fieldName,minOccurs,maxOccurs,type,valueConverter;for(var i=0;i<numChildren;i+=1){seqChild=seqChildren.item(i);if(seqChild.nodeType!==1){continue;}
fieldLabel=_getAttributeNS(seqChild,_xmlnsSQL,_xmlnsSQLPrefix,"field");fieldName=seqChild.getAttribute("name");type=seqChild.getAttribute("type");if(type===null&&this._row){var val=this._row.getElementsByTagName(fieldName);if(val.length){type=_getAttributeNS(val.item(0),_xmlnsSchemaInstance,_xmlnsSchemaInstancePrefix,"type");}}
if(type===null)
type="string";var p=type.indexOf(":");if(p!=-1)
type=type.substring(p+1);if(!type&&this._type==Xmla.DISCOVER_SCHEMA_ROWSETS&&fieldName==="Restrictions"){type="Restrictions";}
minOccurs=seqChild.getAttribute("minOccurs");if(minOccurs){minOccurs=parseInt(minOccurs,10);}
else{minOccurs=1;}
maxOccurs=seqChild.getAttribute("maxOccurs");if(maxOccurs){if(maxOccurs==="unbounded"){maxOccurs=Infinity;}
else{minOccurs=parseInt(maxOccurs,10);}}
else{maxOccurs=1;}
valueConverter=this._getValueConverter(type);this.fields[fieldLabel]={name:fieldName,label:fieldLabel,index:this._fieldCount++,type:type,jsType:valueConverter.jsType,minOccurs:minOccurs,maxOccurs:maxOccurs,getter:this._createFieldGetter(fieldName,valueConverter.func,minOccurs,maxOccurs)};this.fieldOrder.push(fieldLabel);}}
else{var testEmpty=_getElementsByTagNameNS(this._node,_xmlnsEmpty,null,"root");if(testEmpty.length==0)
Xmla.Exception._newError("ERROR_PARSING_RESPONSE","Xmla.Rowset",this._node,null)._throw();}},_boolConverter:function(val){return val==="true"?true:false;},_intConverter:function(val){return parseInt(val,10);},_floatConverter:function(val){return parseFloat(val,10);},_textConverter:function(val){return val;},_dateTimeConverter:function(val){return new Date(Date.parse(val));},_restrictionsConverter:function(val){return val;},_arrayConverter:function(nodes,valueConverter){var arr=[],numNodes=nodes.length,node;for(var i=0;i<numNodes;i+=1){node=nodes.item(i);arr.push(valueConverter(this._elementText(node)));}
return arr;},_elementText:function(el){if(el==null)
return null;if(el.innerText){return el.innerText;}
else
if(el.textContent){return el.textContent;}
else
if(el.normalize){el.normalize();if(el.firstChild){return el.firstChild.data;}
else{return null;}}
else{var text="",childNodes=el.childNodes,numChildNodes=childNodes.length;for(var i=0;i<numChildNodes;i+=1){text+=childNodes.item(i).data;}
return text;}},_getValueConverter:function(type){var valueConverter={};switch(type){case"boolean":valueConverter.func=this._boolConverter;valueConverter.jsType="boolean";break;case"decimal":case"double":case"float":valueConverter.func=this._floatConverter;valueConverter.jsType="number";break;case"int":case"integer":case"nonPositiveInteger":case"negativeInteger":case"nonNegativeInteger":case"positiveInteger":case"short":case"byte":case"long":case"unsignedLong":case"unsignedInt":case"unsignedShort":case"unsignedByte":valueConverter.func=this._intConverter;valueConverter.jsType="number";break;case"string":valueConverter.func=this._textConverter;valueConverter.jsType="string";break;case"dateTime":valueConverter.func=this._dateTimeConverter;valueConverter.jsType="object";break;case"Restrictions":valueConverter.func=this._restrictionsConverter;valueConverter.jsType="object";break;default:valueConverter.func=this._textConverter;valueConverter.jsType="object";break;}
return valueConverter;},_createFieldGetter:function(fieldName,valueConverter,minOccurs,maxOccurs){var me=this;var getter;if(maxOccurs===1){if(minOccurs===1){getter=function(){var els=_getElementsByTagNameNS(this._row,_xmlnsRowset,null,fieldName);var val=me._elementText(els.item(0));return val?valueConverter(val):null;};}
else
if(minOccurs===0){getter=function(){var els=_getElementsByTagNameNS(this._row,_xmlnsRowset,null,fieldName);if(els.length){var val=me._elementText(els.item(0));return val?valueConverter(val):null;}
else{return null;}};}}
else
if(minOccurs===1){getter=function(){var els=_getElementsByTagNameNS(this._row,_xmlnsRowset,null,fieldName);return me._arrayConverter(els,valueConverter);};}
else
if(minOccurs===0){getter=function(){var els=_getElementsByTagNameNS(this._row,_xmlnsRowset,null,fieldName);if(els.length){return me._arrayConverter(els,valueConverter);}
else{return null;}};}
return getter;},getType:function(){return this._type;},getFields:function(){var f=[],fieldCount=this._fieldCount,fieldOrder=this.fieldOrder;for(var i=0;i<fieldCount;i+=1){f[i]=this.fieldDef(fieldOrder[i]);}
return f;},getFieldNames:function(){var fieldNames=[];for(var i=0,count=this.fieldCount();i<count;i+=1){fieldNames[i]=this.fieldOrder[i];}
return fieldNames;},hasMoreRows:function(){return this.numRows>this.rowIndex;},next:function(){this.rowIndex+=1;this._row=this._rows.item(this.rowIndex);},curr:function(){return this.rowIndex;},rowCount:function(){return this.numRows;},reset:function(){this.rowIndex=0;this._row=(this.hasMoreRows())?this._rows.item(this.rowIndex):null;},fieldDef:function(name){var field=this.fields[name];if(!field){Xmla.Exception._newError("INVALID_FIELD","Xmla.Rowset.fieldDef",name,null)._throw();}
return field;},fieldIndex:function(name){var fieldDef=this.fieldDef(name);return fieldDef.index;},fieldName:function(index){var fieldName=this.fieldOrder[index];if(!fieldName){Xmla.Exception._newError("INVALID_FIELD","Xmla.Rowset.fieldDef",index,null)._throw();}
return fieldName;},fieldVal:function(name){if(typeof(name)==="number"){name=this.fieldName(name);}
var field=this.fieldDef(name);return field.getter.call(this);},fieldCount:function(){return this._fieldCount;},close:function(){this._node=null;this._row=null;this._rows=null;},readAsArray:function(){var array=[],fields=this.fields,fieldName,fieldDef;for(fieldName in fields){if(fields.hasOwnProperty(fieldName)){fieldDef=fields[fieldName];array[fieldDef.index]=fieldDef.getter.call(this);}}
return array;},fetchAsArray:function(){var array;if(this.hasMoreRows()){array=this.readAsArray();this.next();}else{array=false;}
return array;},readAsObject:function(){var object={},fields=this.fields,fieldName,fieldDef;for(fieldName in fields){if(fields.hasOwnProperty(fieldName)){fieldDef=fields[fieldName];object[fieldName]=fieldDef.getter.call(this);}}
return object;},fetchAsObject:function(){var object;if(this.hasMoreRows()){object=this.readAsObject();this.next();}else{object=false;}
return object;},fetchCustom:function(func){var object;if(this.hasMoreRows()){object=func.call(this);this.next();}else{object=false;}
return object;},fetchAllAsArray:function(rows){var row;if(!rows){rows=[];}
while((row=this.fetchAsArray())){rows.push(row);}
return rows;},fetchAllAsObject:function(rows){var row;if(!rows){rows=[];}
while((row=this.fetchAsObject())){rows.push(row);}
return rows;},fetchAllCustom:function(rows,func){var row;if(!rows){rows=[];}
while((row=this.fetchCustom(func))){rows.push(row);}
return rows;},mapAsObject:function(map,key,row){var k,v,p,i,len=key.length,last=len-1,m=map;for(i=0;i<len;i+=1){k=key[i];v=row[k];p=m[v];if(p){if(i===last){if(p instanceof Array){p.push(row);}
else{m[v]=[p,row];}}
else{m=p;}}
else
if(i===last){m[v]=row;}else{m=m[v]={};}}},mapAllAsObject:function(key,map){if(!map){map={};}
if(!key){key=this.getKey();}
var row;while(row=this.fetchAsObject()){this.mapAsObject(map,key,row);}
return map;},getKey:function(){var key;if(this._type){key=Xmla.Rowset.KEYS[this._type];}
else{key=this.getFieldNames();}
return key;}};Xmla.Exception=function(type,code,message,helpfile,source,data){this.type=type;this.code=code;this.message=message;this.source=source;this.helpfile=helpfile;this.data=data;return this;};Xmla.Exception.TYPE_WARNING="warning";Xmla.Exception.TYPE_ERROR="error";var _exceptionHlp="http://code.google.com/p/xmla4js/wiki/ExceptionCodes";Xmla.Exception.MISSING_REQUEST_TYPE_CDE=-1;Xmla.Exception.MISSING_REQUEST_TYPE_MSG="Missing_Request_Type";Xmla.Exception.MISSING_REQUEST_TYPE_HLP=_exceptionHlp+"#"+Xmla.Exception.MISSING_REQUEST_TYPE_CDE+"_"+Xmla.Exception.MISSING_REQUEST_TYPE_MSG;Xmla.Exception.MISSING_STATEMENT_CDE=-2;Xmla.Exception.MISSING_STATEMENT_MSG="Missing_Statement";Xmla.Exception.MISSING_STATEMENT_HLP=_exceptionHlp+"#"+Xmla.Exception.MISSING_STATEMENT_CDE+"_"+Xmla.Exception.MISSING_STATEMENT_MSG;Xmla.Exception.MISSING_URL_CDE=-3;Xmla.Exception.MISSING_URL_MSG="Missing_URL";Xmla.Exception.MISSING_URL_HLP=_exceptionHlp+"#"+Xmla.Exception.MISSING_URL_CDE+"_"+Xmla.Exception.MISSING_URL_MSG;Xmla.Exception.NO_EVENTS_SPECIFIED_CDE=-4;Xmla.Exception.NO_EVENTS_SPECIFIED_MSG="No_Events_Specified";Xmla.Exception.NO_EVENTS_SPECIFIED_HLP=_exceptionHlp+"#"+Xmla.Exception.NO_EVENTS_SPECIFIED_CDE+"_"+Xmla.Exception.NO_EVENTS_SPECIFIED_MSG;Xmla.Exception.WRONG_EVENTS_FORMAT_CDE=-5;Xmla.Exception.WRONG_EVENTS_FORMAT_MSG="Wrong_Events_Format";Xmla.Exception.WRONG_EVENTS_FORMAT_HLP=_exceptionHlp+"#"+Xmla.Exception.NO_EVENTS_SPECIFIED_CDE+"_"+Xmla.Exception.NO_EVENTS_SPECIFIED_MSG;Xmla.Exception.UNKNOWN_EVENT_CDE=-6;Xmla.Exception.UNKNOWN_EVENT_MSG="Unknown_Event";Xmla.Exception.UNKNOWN_EVENT_HLP=_exceptionHlp+"#"+Xmla.Exception.UNKNOWN_EVENT_CDE+"_"+Xmla.Exception.UNKNOWN_EVENT_MSG;Xmla.Exception.INVALID_EVENT_HANDLER_CDE=-7;Xmla.Exception.INVALID_EVENT_HANDLER_MSG="Invalid_Events_Handler";Xmla.Exception.INVALID_EVENT_HANDLER_HLP=_exceptionHlp+"#"+Xmla.Exception.INVALID_EVENT_HANDLER_CDE+"_"+Xmla.Exception.INVALID_EVENT_HANDLER_MSG;Xmla.Exception.ERROR_PARSING_RESPONSE_CDE=-8;Xmla.Exception.ERROR_PARSING_RESPONSE_MSG="Error_Parsing_Response";Xmla.Exception.ERROR_PARSING_RESPONSE_HLP=_exceptionHlp+"#"+Xmla.Exception.ERROR_PARSING_RESPONSE_CDE+"_"+Xmla.Exception.ERROR_PARSING_RESPONSE_MSG;Xmla.Exception.INVALID_FIELD_CDE=-9;Xmla.Exception.INVALID_FIELD_MSG="Invalid_Field";Xmla.Exception.INVALID_FIELD_HLP=_exceptionHlp+"#"+Xmla.Exception.INVALID_FIELD_CDE+"_"+Xmla.Exception.INVALID_FIELD_MSG;Xmla.Exception.HTTP_ERROR_CDE=-10;Xmla.Exception.HTTP_ERROR_MSG="HTTP Error";Xmla.Exception.HTTP_ERROR_HLP=_exceptionHlp+"#"+Xmla.Exception.HTTP_ERROR_CDE+"_"+Xmla.Exception.HTTP_ERROR_MSG;Xmla.Exception._newError=function(codeName,source,data,srvResponse){var xmlDoc=null;if(srvResponse!=null){xmlDoc=_createXmlDoc(srvResponse);var soapFault=_getElementsByTagNameNS(xmlDoc,_xmlnsSOAPenvelope,_xmlnsSOAPenvelopePrefix,"Fault");if(soapFault.length){var _faultcode=soapFault.item(0).getElementsByTagName("faultcode");if(_faultcode.length>0){return new Xmla.Exception(Xmla.Exception.TYPE_ERROR,soapFault.item(0).getElementsByTagName("faultcode").item(0).childNodes.item(0).data,soapFault.item(0).getElementsByTagName("faultstring").item(0).childNodes.item(0).data,null,"_requestError",data);}else{var fDetail=_getElementsByTagNameNS(xmlDoc,_xmlnsSOAPenvelope,_xmlnsSOAPenvelopePrefix,"Detail");if(fDetail.length>0){try{var _err=soapFault.item(0).getElementsByTagName("Error").item(0);return new Xmla.Exception(Xmla.Exception.TYPE_ERROR,_err.getAttribute("ErrorCode"),_err.getAttribute("Description"),null,"_requestError",data);}catch(e){return new Xmla.Exception(Xmla.Exception.TYPE_ERROR,"-1",srvResponse,null,"_requestError",data);}}else{var fText=_getElementsByTagNameNS(xmlDoc,_xmlnsSOAPenvelope,_xmlnsSOAPenvelopePrefix,"Text");if(fText.length>0){return new Xmla.Exception(Xmla.Exception.TYPE_ERROR,"-1",fText.item(0).childNodes.item(0).data,null,"_requestError",data);}else{return new Xmla.Exception(Xmla.Exception.TYPE_ERROR,"-1","UNKNOWN Error",null,"_requestError",data);}}}}}
return new Xmla.Exception(Xmla.Exception.TYPE_ERROR,Xmla.Exception[codeName+"_CDE"],Xmla.Exception[codeName+"_MSG"],Xmla.Exception[codeName+"_HLP"],source,data);};Xmla.Exception.prototype={type:null,code:null,message:null,source:null,helpfile:null,data:null,_throw:function(){throw this;}};}());